unit mbTBXFixedStuff;

{$I mxs.inc}

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, TBXDkPanels, TBX, TBXThemes;

type
  TmbTBXLabel = class(TTBXLabel)
  protected
   procedure TBMThemeChange(var Message: TMessage); message TBM_THEMECHANGE;
  end;

  TmbTBXCheckBox = class(TTBXCheckBox)
  protected
   procedure TBMThemeChange(var Message: TMessage); message TBM_THEMECHANGE;
  end;

  TmbTBXRadioButton = class(TTBXRadioButton)
  protected
   procedure TBMThemeChange(var Message: TMessage); message TBM_THEMECHANGE;
  end;

implementation

function GetInfo(Enabled: boolean): TTBXItemInfo;
var
 IInfo: TTBXItemInfo;
begin
 FillChar(IInfo, SizeOf(TTBXItemInfo), 0);
 IInfo.ViewType := TVT_NORMALTOOLBAR;
 IInfo.ItemOptions := IO_APPACTIVE or IO_TOOLBARSTYLE;
 IInfo.Enabled := Enabled;
 IInfo.Pushed := false;
 IInfo.Selected := false;
 IInfo.HoverKind := hkNone;
end;

{ mbTBXLabel }

procedure TmbTBXLabel.TBMThemeChange(var Message: TMessage);
begin
 inherited;
 if Message.WParam = TSC_VIEWCHANGE then
  Font.Color := CurrentTheme.GetItemTextColor(GetInfo(Enabled));
end;

{ mbTBXCheckBox }

procedure TmbTBXCheckBox.TBMThemeChange(var Message: TMessage);
begin
 inherited;
 if Message.WParam = TSC_VIEWCHANGE then
  Font.Color := CurrentTheme.GetItemTextColor(GetInfo(Enabled));
end;

{ mbTBXRadioButton }

procedure TmbTBXRadioButton.TBMThemeChange(var Message: TMessage);
begin
 inherited;
 if Message.WParam = TSC_VIEWCHANGE then
  Font.Color := CurrentTheme.GetItemTextColor(GetInfo(Enabled));
end;

end.

